
// edgeSearchingDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "edgeSearching.h"
#include "edgeSearchingDlg.h"
#include "afxdialogex.h"
#include"SetNoise.h" 
#include"commonPara.h"
#include"ShowInfo.h"
#include"AddBoxFilterKenelValue.h"
#include"com.fanyu.Filter.h"
#include"com.fanyu.Enhance.h"
#include"com.fanyu.EdgeCheck.h"
#include"SetCannyPara.h"
#include"com.fanyu.CreateNoise.h"
#include"SetSobelPara.h"
#include<atlimage.h>
#include"SetLaplaceHole.h"
#include"Paint.h"

#include <opencv2/core/core.hpp>  
#include <opencv2/highgui/highgui.hpp>  

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

	// Ի
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

	// ʵ
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnOpenFile_Menu();
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)


END_MESSAGE_MAP()


// CedgeSearchingDlg Ի


CedgeSearchingDlg::CedgeSearchingDlg(CWnd* pParent /*=NULL*/)
: CDialogEx(CedgeSearchingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CedgeSearchingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SHOWORGIMAGE_STATIC, m_Show_ORG_Picture);
}

BEGIN_MESSAGE_MAP(CedgeSearchingDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_32771, &CedgeSearchingDlg::OnOpenFile)
	ON_COMMAND(ID_32782, &CedgeSearchingDlg::OnCreateGaNoise)
	ON_COMMAND(ID_32783, &CedgeSearchingDlg::OnAddPSNoise)
	ON_COMMAND(ID_32784, &CedgeSearchingDlg::OnBoxFilter)
	ON_COMMAND(ID_32819, &CedgeSearchingDlg::OnFilterIntroduction)
	ON_COMMAND(ID_32785, &CedgeSearchingDlg::OnAverageFilter)
	ON_COMMAND(ID_32776, &CedgeSearchingDlg::OnExpEnhance)
	ON_COMMAND(ID_32820, &CedgeSearchingDlg::OnLogEnhance)
	ON_COMMAND(ID_32792, &CedgeSearchingDlg::OnHighPass)
	ON_COMMAND(ID_32791, &CedgeSearchingDlg::OnExplorOver)
	ON_COMMAND(ID_32778, &CedgeSearchingDlg::OnCanny)
	ON_BN_CLICKED(IDC_BUTTON_GRAY, &CedgeSearchingDlg::OnBnClickedButtonGray)
	ON_BN_CLICKED(IDC_BUTTON_BINARY, &CedgeSearchingDlg::OnBnClickedButtonBinary)
	ON_COMMAND(ID_32786, &CedgeSearchingDlg::OnGaussianFilter)
	ON_COMMAND(ID_32773, &CedgeSearchingDlg::OnExit)
	ON_COMMAND(ID_32772, &CedgeSearchingDlg::OnSave)
	ON_COMMAND(ID_32797, &CedgeSearchingDlg::OnGaInfo)
	ON_COMMAND(ID_32798, &CedgeSearchingDlg::OnPSInfo)
	ON_COMMAND(ID_32788, &CedgeSearchingDlg::OnMediumFilter)
	ON_COMMAND(ID_32789, &CedgeSearchingDlg::OnDoubleEdgeFilter)
	ON_COMMAND(ID_32790, &CedgeSearchingDlg::OnWaveChange)
	ON_COMMAND(ID_32800, &CedgeSearchingDlg::OnBoxFilterInfo)
	ON_COMMAND(ID_32801, &CedgeSearchingDlg::OnAverageFilterInfo)
	ON_COMMAND(ID_32802, &CedgeSearchingDlg::OnGauFilterInfo)
	ON_COMMAND(ID_32803, &CedgeSearchingDlg::OnMediumFilterInfo)
	ON_COMMAND(ID_32804, &CedgeSearchingDlg::OnDouFilterInfo)
	ON_COMMAND(ID_32805, &CedgeSearchingDlg::OnWaveInfo)
	ON_COMMAND(ID_32807, &CedgeSearchingDlg::OnExpInfo)
	ON_COMMAND(ID_32808, &CedgeSearchingDlg::OnLogInfo)
	ON_COMMAND(ID_32809, &CedgeSearchingDlg::OnHPInfo)
	ON_COMMAND(ID_32810, &CedgeSearchingDlg::OnHConvInfo)
	ON_COMMAND(ID_32779, &CedgeSearchingDlg::OnRoberts)
	ON_COMMAND(ID_32780, &CedgeSearchingDlg::OnSobel)
	ON_COMMAND(ID_32781, &CedgeSearchingDlg::OnLaplace)
	ON_COMMAND(ID_32793, &CedgeSearchingDlg::OnSusan)
	ON_COMMAND(ID_32794, &CedgeSearchingDlg::OnKrisch)
	ON_COMMAND(ID_32795, &CedgeSearchingDlg::OnPrewitt)
	ON_COMMAND(ID_32812, &CedgeSearchingDlg::OnCannyInfo)
	ON_COMMAND(ID_32813, &CedgeSearchingDlg::OnRobertsInfo)
	ON_COMMAND(ID_32814, &CedgeSearchingDlg::OnSobelInfo)
	ON_COMMAND(ID_32815, &CedgeSearchingDlg::OnLaplaceInfo)
	ON_COMMAND(ID_32816, &CedgeSearchingDlg::OnSusanInfo)
	ON_COMMAND(ID_32817, &CedgeSearchingDlg::OnKrischInfo)
	ON_COMMAND(ID_32818, &CedgeSearchingDlg::OnPrewittInfo)
	ON_BN_CLICKED(IDC_BUTTON_AUTOCHECK, &CedgeSearchingDlg::OnBnClickedButtonAutocheck)
	ON_BN_CLICKED(IDC_SAVE_PICTURE_BUTTON, &CedgeSearchingDlg::OnBnClickedSavePictureButton)
	ON_BN_CLICKED(IDC__AMPLIFICATION_BUTTON, &CedgeSearchingDlg::OnBnClickedButtonAmpl)
	ON_BN_CLICKED(IDC_BUTTON_HAND_FIX, &CedgeSearchingDlg::OnBnClickedButtonHandFix)
	ON_BN_CLICKED(IDC_BUTTON_ANALISE, &CedgeSearchingDlg::OnBnClickedButtonAnalise)
END_MESSAGE_MAP()


// CedgeSearchingDlg Ϣ

BOOL CedgeSearchingDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶Իͼꡣ  ӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	ShowWindow(SW_MAXIMIZE);

	// TODO:  ڴӶĳʼ
	m_Menu.LoadMenu(IDR_MENU1);//ز˵
	SetMenu(&m_Menu);
	
	CONTINUE=true;//Ҷͼתִֻһα־
	InitFlag = true;//ʼһα־


	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CedgeSearchingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣ  ʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CedgeSearchingDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();

		//// ӴԻ򱳾ͼ
		//CPaintDC   dc(this);
		//CRect   rect;
		//GetClientRect(&rect);    //ȡԻ򳤿      
		//
		//CDC   dcBmp;             //岢һڴ豸
		//dcBmp.CreateCompatibleDC(&dc);             //DC
		//
		//CBitmap   bmpBackground;
		//bmpBackground.LoadBitmap(IDB_BITMAP2);    //ԴͼƬ
		//
		//BITMAP   m_bitmap;                         //ͼƬ               
		//bmpBackground.GetBitmap(&m_bitmap);       //ͼƬλͼ
		//
		////λͼѡʱڴ豸
		//CBitmap  *pbmpOld = dcBmp.SelectObject(&bmpBackground);
		//
		////úʾͼƬStretchBltʾ״ɱ
		//dc.StretchBlt(0, 0, rect.Width(), rect.Height(), &dcBmp, 0, 0, m_bitmap.bmWidth, m_bitmap.bmHeight, SRCCOPY);
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CedgeSearchingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/***********************************************
 *                     ˵¼
 *
 *
 **
 ***********************************************/
/*--------------------ж----------------------*/
static CString FILEPATH;//ͼƬļַ

//干Mat
static cv::Mat orgMat;//ʼ
static cv::Mat noiMat;//
static cv::Mat filMat;//˲
static cv::Mat enhMat;//ǿ
static cv::Mat edgMat;//Ե
static cv::Mat graMat;//Ҷͼ
static cv::Mat binMat;//ֵ
extern cv::Mat cMat;//cppй

//ʼ
void InitMat()
{
	if (InitFlag)
		InitFlag = false;
	
	binMat = edgMat = enhMat = filMat = noiMat = orgMat;
}
/*--------------------END----------------------*/

/*------------------------------Ա---------------------------------*/

//ڶԻʾͼƬ
void CedgeSearchingDlg::showImage(IplImage* image, UINT ID){

	//MatʾpictureؼҪĶ
	static CDC *pDC;
	static HDC hDC;
	static CRect rect;
	static CvvImage cimg;

	pDC = GetDlgItem(ID)->GetDC();
	hDC = pDC->GetSafeHdc();

	GetDlgItem(ID)->GetClientRect(&rect);

	cimg.CopyOf(image, image->nChannels);
	cimg.DrawToHDC(hDC, &rect);
	
	ReleaseDC(pDC);
}

//ͼƬַݺ
void getFilePath(CString BmpName)
{
	FILEPATH = BmpName;
}


//˵->ļ->
void CedgeSearchingDlg::OnOpenFile()
{
	//ļ ָʽļbmp gif jpg tiff
	CString filter;
	filter = "ļ(*.bmp,*.jpg,*.gif,*tiff)|*.bmp;*.jpg;*.gif;*.tiff| BMP(*.bmp)|*.bmp| JPG(*.jpg)|*.jpg| GIF(*.gif)|*.gif| TIFF(*.tiff)|*.tiff||";

	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, filter, NULL);

	//ȷť dlg.DoModal() ʾԻ
	if (dlg.DoModal() == IDOK)
	{
		//򿪶ԻȡͼϢ
		CString BmpName = dlg.GetPathName();     //ȡļ·   D:\pic\abc.bmp
		CString EntName = dlg.GetFileExt();      //ȡļչ

		getFilePath(BmpName);//ȡļַԺ

		EntName.MakeLower();                     //ļչתΪһСдַ

		if (EntName.Compare(_T("bmp")) == 0)
		{
			//洢ͼƬϢ
			BITMAPINFO *pBmpInfo;       //¼ͼϸ
			BYTE *pBmpData;             //ͼ
			BITMAPFILEHEADER bmpHeader; //ļͷ
			BITMAPINFOHEADER bmpInfo;   //Ϣͷ
			CFile bmpFile;              //¼ļ

			//ֻķʽļ ȡbmpͼƬ bmpļͷ Ϣ 
			if (!bmpFile.Open(BmpName, CFile::modeRead | CFile::typeBinary))
				return;
			if (bmpFile.Read(&bmpHeader, sizeof(BITMAPFILEHEADER)) != sizeof(BITMAPFILEHEADER))
				return;
			if (bmpFile.Read(&bmpInfo, sizeof(BITMAPINFOHEADER)) != sizeof(BITMAPINFOHEADER))
				return;
			pBmpInfo = (BITMAPINFO *)new char[sizeof(BITMAPINFOHEADER)];

			//Ϊͼռ
			memcpy(pBmpInfo, &bmpInfo, sizeof(BITMAPINFOHEADER));
			DWORD dataBytes = bmpHeader.bfSize - bmpHeader.bfOffBits;
			pBmpData = (BYTE*)new char[dataBytes];
			bmpFile.Read(pBmpData, dataBytes);
			bmpFile.Close();

			/*ΪMatĹʹ*/
			//CSringתΪString
			USES_CONVERSION;
			String str(W2A(FILEPATH));
			orgMat = imread(str, 3);//ѶMat浽cMat

			//ʾͼ
			CRect rect;
			static CDC *pDC;
			CWnd *pWnd = GetDlgItem(IDC_SHOWORGIMAGE_STATIC); //pictrueؼڵľ
			pWnd->GetClientRect(&rect); //pictrueؼڵľ
			pDC = pWnd->GetDC(); //pictrueؼDC
			pDC->SetStretchBltMode(COLORONCOLOR);
			StretchDIBits(pDC->GetSafeHdc(), 0, 0, rect.Width(), rect.Height(), 0, 0,
				bmpInfo.biWidth, bmpInfo.biHeight, pBmpData, pBmpInfo, DIB_RGB_COLORS, SRCCOPY);
		}
	}
	CONTINUE = true;//Ҷͼť
	InitMat();//ʼʹõMat
}

//˵->ļ->˳
void CedgeSearchingDlg::OnExit()
{
	EndDialog(IDD_EDGESEARCHING_DIALOG);
}

//˵->ļ->
void CedgeSearchingDlg::OnSave()
{
	CString saveFilePath;
	CClientDC dc(this);
    CRect rect;
	BOOL  showMsgTag = FALSE;                  //ǷҪͼ񱣴ɹԻ" 

	GetClientRect(&rect);                  //ȡС

	HBITMAP hbitmap = CreateCompatibleBitmap(dc, rect.right - rect.left, rect.bottom - rect.top);
	
	//λͼ

	HDC hdc = CreateCompatibleDC(dc);      //DCԱ㽫ͼ񱣴Ϊͬĸʽ

	HBITMAP hOldMap = (HBITMAP)SelectObject(hdc, hbitmap);

	//λͼѡDC淵ֵ 

	BitBlt(hdc, 0, 0, rect.right - rect.left, rect.bottom - rect.top, dc, 0, 0, SRCCOPY);

	//ĻDCͼƵڴDC
	ATL::CImage image;

	image.Attach(hbitmap);

	BOOL saveTag = FALSE;

	if (!saveTag)                          //ͼǵһαд,򿪶Ի
	{
		saveTag = TRUE;

		showMsgTag = TRUE;

		CString  strFilter = _T("λͼļ(*.bmp)|*.bmp|JPEG ͼļ|*.jpg|GIFͼļ | *.gif | PNGͼļ | *.png |ʽ(*.*) | *.* || ");
		CFileDialog dlg(FALSE, _T("bmp"), _T("iPaint1.bmp"), NULL, strFilter);

		if (dlg.DoModal() != IDOK)
			return;

		CString strFileName;          //ûûָļչΪһ
		CString strExtension;
		strFileName = dlg.m_ofn.lpstrFile;

		if (dlg.m_ofn.nFileExtension = 0)               //չĿΪ0
		{
			switch (dlg.m_ofn.nFilterIndex)
			{
			case 1:
				strExtension = "bmp"; break;
			case 2:
				strExtension = "jpg"; break;
			case 3:
				strExtension = "gif"; break;
			case 4:
				strExtension = "png"; break;
			default:
				break;
			}

			strFileName = strFileName + "." + strExtension;

		}

		saveFilePath = strFileName;     //saveFilePathΪеȫֱ,ΪCString
	}

	else
		showMsgTag = FALSE;

	//AfxMessageBox(saveFilePath);               //ʾͼ񱣴ȫ·(ļ)

	HRESULT hResult = image.Save(saveFilePath);     //ͼ

	if (FAILED(hResult))

	{

		MessageBox(_T("ͼļʧܣ"));

	}

	else

	{

		if (showMsgTag)

			MessageBox(_T("ļɹ"));

	}

	image.Detach();

	SelectObject(hdc, hOldMap);

}



//˵->->˹
void CedgeSearchingDlg::OnCreateGaNoise()
{
	noiMat = orgMat;//ͼ

	CreateNoise *m_CreateGaNoise = NULL;  //һ
	m_CreateGaNoise->AddGaussianNoise(noiMat);  //ø˹

	delete m_CreateGaNoise; //ͷ

	showImage(&(IplImage)noiMat, IDC_SHOW_NOISE_PICTURE_STATIC);//ʾͼƬָؼ
}

//˵->->
void CedgeSearchingDlg::OnAddPSNoise()
{
	INT_PTR nRes;//ڱDomodalķֵ

	CSetNoise m_SetNoiseN;//SetNoiseNʵ
	
    m_SetNoiseN.m_SetNoise=1000;//Ĭֵ
	UpdateData(FALSE);

	nRes = m_SetNoiseN.DoModal();//

	if (nRes == IDCANCEL)//ж϶Ի򷵻ֵǷΪCANCELʵ򷵻
		return;

	else if (nRes == IDOK)
		UpdateData(TRUE);//ѿؼֵµ

		int NoiseN = m_SetNoiseN.m_SetNoise;//ȡؼֵNoiseNʾ

		noiMat = orgMat;//ȡMat

		CreateNoise *m_CreatePSNoise = NULL;  //һ
		m_CreatePSNoise->AddPepperNoise(noiMat, NoiseN);  //ý
		m_CreatePSNoise->AddSaltNoise(noiMat, NoiseN);

		delete m_CreatePSNoise; //ͷ

		showImage(&(IplImage)noiMat, IDC_SHOW_NOISE_PICTURE_STATIC);//ʾͼƬָؼ

}


//˵->->˹
void CedgeSearchingDlg::OnGaInfo()
{
	// TODO:  ڴ
}

//˵->->
void CedgeSearchingDlg::OnPSInfo()
{
}
 


//˵->˲->˲
void CedgeSearchingDlg::OnBoxFilter()
{
	CAddBoxFilterKenelValue m_BoxFilter;//

	INT_PTR nResB;
	
	m_BoxFilter.m_AddBoxFilterKenelValue=5;//Ĭֵ
	UpdateData(FALSE);

	nResB = m_BoxFilter.DoModal();//

	Filter mFilter(noiMat); //ʼ˲

	if (nResB==IDCANCEL)
		return;

	if (nResB == IDOK)//ȷ
		UpdateData(TRUE);

	mFilter.kenelValue = m_BoxFilter.m_AddBoxFilterKenelValue;//ȡؼֵ
	mFilter.dDepth = -1;//ͼΪԭͼ

	mFilter.boxFilter();//÷˲dstMat

	filMat = mFilter.dstMat;//Ŀͼ浽cMat

	showImage(&(IplImage)filMat, IDC_SHOW_FILTER_PICTURE_STATIC);//ʾͼƬָؼ
}

//˵->˲->ֵ˲
void CedgeSearchingDlg::OnAverageFilter()
{
	CAddBoxFilterKenelValue m_BlurFilter;//
	m_BlurFilter.m_AddBoxFilterKenelValue=7;//Ĭֵ
	UpdateData(FALSE);

	INT_PTR nResB;
	nResB = m_BlurFilter.DoModal();//

	Filter mFilter(noiMat); //ʼ˲
	
	if (nResB == IDCANCEL)
		return;

	if (nResB == IDOK)//ȷ
		UpdateData(TRUE);

	mFilter.kenelValue = m_BlurFilter.m_AddBoxFilterKenelValue;//ȡؼֵ
	mFilter.dDepth = -1;//ͼΪԭͼ

	mFilter.averageFilter();//˲dstMat

	filMat = mFilter.dstMat;//Ŀͼ浽cMat

	showImage(&(IplImage)filMat, IDC_SHOW_FILTER_PICTURE_STATIC);//ʾͼƬָؼ
}

//˵->˲->˹˲
void CedgeSearchingDlg::OnGaussianFilter()
{
	CAddBoxFilterKenelValue m_GauFilter;//
	m_GauFilter.m_AddBoxFilterKenelValue = 3;//Ĭֵ
	UpdateData(FALSE);

	INT_PTR nResB;
	nResB = m_GauFilter.DoModal();//

	Filter mFilter(noiMat); //ʼ˲

	if (nResB == IDCANCEL)
		return;

	if (nResB == IDOK)//ȷ
		UpdateData(TRUE);

	mFilter.kenelValue = m_GauFilter.m_AddBoxFilterKenelValue;//ȡؼֵ
	mFilter.dDepth = -1;//ͼΪԭͼ

	mFilter.GaussianFilter();//˲dstMat

	filMat = mFilter.dstMat;//Ŀͼ浽cMat

	showImage(&(IplImage)filMat, IDC_SHOW_FILTER_PICTURE_STATIC);//ʾͼƬָؼ
}

//˵->˲->ֵ˲
void CedgeSearchingDlg::OnMediumFilter()
{
	CAddBoxFilterKenelValue m_MedFilter;//

	INT_PTR nResB;
	
	m_MedFilter.m_AddBoxFilterKenelValue = 7;//Ĭֵ
	UpdateData(FALSE);

	nResB = m_MedFilter.DoModal();//

	Filter mFilter(noiMat); //ʼ˲

	if (nResB == IDCANCEL)
		return;

	if (nResB == IDOK)//ȷ
		UpdateData(TRUE);

	mFilter.kenelValue = m_MedFilter.m_AddBoxFilterKenelValue;//ȡؼֵ
	mFilter.dDepth = -1;//ͼΪԭͼ

	mFilter.medianFilter();//˲dstMat

	filMat = mFilter.dstMat;//Ŀͼ浽cMat

	showImage(&(IplImage)filMat, IDC_SHOW_FILTER_PICTURE_STATIC);//ʾͼƬָؼ
}

//˵->˲->˫˲
void CedgeSearchingDlg::OnDoubleEdgeFilter()
{
	CAddBoxFilterKenelValue m_DouFilter;//
	m_DouFilter.m_AddBoxFilterKenelValue = 25;//Ĭֵ
	UpdateData(FALSE);

	INT_PTR nResB;
	nResB = m_DouFilter.DoModal();//

	Filter mFilter(noiMat); //ʼ˲

	if (nResB == IDCANCEL)
		return;

	if (nResB == IDOK)//ȷ
		UpdateData(TRUE);

	mFilter.kenelValue = m_DouFilter.m_AddBoxFilterKenelValue;//ȡؼֵ
	mFilter.dDepth = -1;//ͼΪԭͼ

	mFilter.bilateralFilter();//˲dstMat

    filMat = mFilter.dstMat;//Ŀͼ浽cMat

	showImage(&(IplImage)filMat, IDC_SHOW_FILTER_PICTURE_STATIC);//ʾͼƬָؼ
}

//˵->˲->С任
void CedgeSearchingDlg::OnWaveChange()
{
	CAddBoxFilterKenelValue m_waveConvert;//
	
	m_waveConvert.m_AddBoxFilterKenelValue=2;//Ĭֵ
	
	INT_PTR nResB;
	nResB = m_waveConvert.DoModal();//

	Filter mFilter(noiMat); //ʼ˲

	if (nResB == IDCANCEL)
		return;

	if (nResB == IDOK)//ȷ
		UpdateData(TRUE);

	mFilter.kenelValue = m_waveConvert.m_AddBoxFilterKenelValue;//ȡؼֵ
	mFilter.dDepth = -1;//ͼΪԭͼ

	mFilter.waveConvert();//˲dstMat

	filMat = mFilter.dstMat;//Ŀͼ浽cMat

	showImage(&(IplImage)filMat, IDC_SHOW_FILTER_PICTURE_STATIC);//ʾͼƬָؼ
}


//˵->˲->鿴˵->ͼ˲
void CedgeSearchingDlg::OnFilterIntroduction()
{
	CShowFilterInfo m_ShowInfo;//ʵ鿴Ϣڶ
	m_ShowInfo.DoModal();//
}

//˵->˲->鿴˵->˲
void CedgeSearchingDlg::OnBoxFilterInfo()
{
	// TODO:  ڴ
}

//˵->˲->鿴˵->ֵ˲
void CedgeSearchingDlg::OnAverageFilterInfo()
{
	// TODO:  ڴ
}

//˵->˲->鿴˵->˹˲
void CedgeSearchingDlg::OnGauFilterInfo()
{
	// TODO:  ڴ
}

//˵->˲->鿴˵->ֵ˲
void CedgeSearchingDlg::OnMediumFilterInfo()
{
	// TODO:  ڴ
}

//˵->˲->鿴˵->˫˲
void CedgeSearchingDlg::OnDouFilterInfo()
{
	// TODO:  ڴ
}

//˵->˲->鿴˵->С任
void CedgeSearchingDlg::OnWaveInfo()
{
	// TODO:  ڴ
}



//˵->ǿ->ָǿ
void CedgeSearchingDlg::OnExpEnhance()
{

	Enhance mEnhance(filMat);//ʼǿ
	Mat dst;
	mEnhance.ExpEnhance(&(IplImage)filMat, &(IplImage)dst);//ָǿ

	enhMat = dst;//enhMat

	showImage(&(IplImage)enhMat, IDC_SHOWENHANCEIMAGE_STATIC);//ʾͼƬָؼ

}

//˵->ǿ->ǿ
void CedgeSearchingDlg::OnLogEnhance()
{
	Enhance mLogEnhance(filMat);//ʼǿ
	Mat dst;
	mLogEnhance.LogEnhance(&(IplImage)filMat, &(IplImage)dst);//ָǿ

	enhMat = dst;//enhMat

	showImage(&(IplImage)enhMat, IDC_SHOWENHANCEIMAGE_STATIC);//ʾͼƬָؼ
}

//˵->ǿ->߷
void CedgeSearchingDlg::OnHighPass()
{
	Enhance mHPEnhance(filMat);//ʼǿ

	enhMat = mHPEnhance.dstMat = mHPEnhance.HighPass();//ø߷

	showImage(&(IplImage)enhMat, IDC_SHOWENHANCEIMAGE_STATIC);//ʾͼƬָؼ

}

//˵->ǿ->ع
void CedgeSearchingDlg::OnExplorOver()
{
	Enhance mEOEnhance(filMat);
	mEOEnhance.ExporeOver(&(IplImage)filMat, &(IplImage)(mEOEnhance.dstMat));

	enhMat = mEOEnhance.dstMat;//洦

	showImage(&(IplImage)enhMat, IDC_SHOWENHANCEIMAGE_STATIC);//ʾͼƬָؼ

}


//˵->ǿ->鿴˵-->ָ
void CedgeSearchingDlg::OnExpInfo()
{
	// TODO:  ڴ
}

//˵->ǿ->鿴˵-->
void CedgeSearchingDlg::OnLogInfo()
{
	// TODO:  ڴ
}

//˵->ǿ->鿴˵-->ع
void CedgeSearchingDlg::OnHPInfo()
{
	// TODO:  ڴ
}

//˵->ǿ->鿴˵-->߷
void CedgeSearchingDlg::OnHConvInfo()
{
	// TODO:  ڴ
}





//˵->->Canny
void CedgeSearchingDlg::OnCanny()
{
	CSetCannyPara m_SetCannyPara;  //ʼ
	
	m_SetCannyPara.m_setCannyValue1=270;//Ĭֵ
	m_SetCannyPara.m_setCannyValue2=270*2/3;
	UpdateData(FALSE);

	INT_PTR nResC;//浯ֵ

	nResC = m_SetCannyPara.DoModal();//ڲȡֵ

	if (nResC == IDCANCEL)
		return;

	else if (nResC == IDOK)//ȷť
		UpdateData(TRUE);//ӿؼֵ

	EdgeCheck mEdgeCheckCanny(enhMat);//ʼԵ
	//ؼֵԵԱ
	mEdgeCheckCanny.thresholdValue1 = m_SetCannyPara.m_setCannyValue1;
	mEdgeCheckCanny.thresholdValue2 = m_SetCannyPara.m_setCannyValue2;

	mEdgeCheckCanny.Canny();//Canny

	edgMat = mEdgeCheckCanny.dstMat;//


	showImage(&(IplImage)edgMat, IDC_SHOWEDGEIMAGE_STATIC);//ʾͼƬָؼ

}

//˵->->Roberts
void CedgeSearchingDlg::OnRoberts()
{
	EdgeCheck m_Roberts(enhMat);//ʼ

	m_Roberts.Roberts();//Roberts

	edgMat=m_Roberts.dstMat;//
	
	showImage(&(IplImage)edgMat, IDC_SHOWEDGEIMAGE_STATIC);//ʾͼƬָؼ

}

//˵->->Soberl
void CedgeSearchingDlg::OnSobel()
{
	//ò
	CSetSobelPara m_setSobelPara;//

	m_setSobelPara.m_Sobeldxdy=2;//Ĭֵ
	m_setSobelPara.m_Sobelhole=3;
	UpdateData(FALSE);

	INT_PTR nResS;

	nResS=m_setSobelPara.DoModal();//

	if (nResS == IDCANCEL)
		return;

	if (nResS == IDOK)//ȷť¿ؼֵ
		UpdateData(TRUE);

	////ü
	EdgeCheck m_SobelCheck(enhMat);//ʼ
	
	//ֵ
	m_SobelCheck.dxdy = m_setSobelPara.m_Sobeldxdy;
	m_SobelCheck.Sobelhole = m_setSobelPara.m_Sobelhole;

	m_SobelCheck.Sobel();//

	edgMat = m_SobelCheck.dstMat;//洢

	showImage(&(IplImage)edgMat, IDC_SHOWEDGEIMAGE_STATIC);//ʾͼƬָؼ
}

//˵->->Laplace
void CedgeSearchingDlg::OnLaplace()
{
	////
	CSetLaplaceHole m_setLaplaceHole;

	m_setLaplaceHole.m_setLaplaceHole=3;//Ĭֵ
	UpdateData(FALSE);

	INT_PTR nResL=m_setLaplaceHole.DoModal();
	
	if (nResL == IDCANCEL)
		return;

	if (nResL == IDOK)//ȷ
		UpdateData(TRUE);

	////
	EdgeCheck m_Laplace(enhMat);

	m_Laplace.LaplaceHole = m_setLaplaceHole.m_setLaplaceHole;//ȡ
	m_Laplace.Laplace();//

	edgMat = m_Laplace.dstMat;//
	
	showImage(&(IplImage)edgMat, IDC_SHOWEDGEIMAGE_STATIC);//ʾͼƬָؼ
}

//˵->->Susan
void CedgeSearchingDlg::OnSusan()
{
	EdgeCheck m_Susan(enhMat);
	m_Susan.Susan();

	edgMat = m_Susan.dstMat;//
	
	showImage(&(IplImage)edgMat, IDC_SHOWEDGEIMAGE_STATIC);//ʾͼƬָؼ
}

//˵->->Krisch
void CedgeSearchingDlg::OnKrisch()
{
	EdgeCheck m_Krisch(enhMat);
	m_Krisch.Krisch();

    edgMat = m_Krisch.dstMat;//
	
	showImage(&(IplImage)edgMat, IDC_SHOWEDGEIMAGE_STATIC);//ʾͼƬָؼ
}

//˵->->Prewitt
void CedgeSearchingDlg::OnPrewitt()
{
	EdgeCheck m_Prewitt(enhMat);
	m_Prewitt.Krisch();

	edgMat = m_Prewitt.dstMat;//

	showImage(&(IplImage)edgMat, IDC_SHOWEDGEIMAGE_STATIC);//ʾͼƬָؼ
}


//˵->->鿴˵-->Cannyӽ
void CedgeSearchingDlg::OnCannyInfo()
{
	// TODO:  ڴ
}

//˵->->鿴˵-->Robertsӽ
void CedgeSearchingDlg::OnRobertsInfo()
{
	// TODO:  ڴ
}

//˵->->鿴˵-->Sobelӽ
void CedgeSearchingDlg::OnSobelInfo()
{
	// TODO:  ڴ
}

//˵->->鿴˵-->Laplaceӽ
void CedgeSearchingDlg::OnLaplaceInfo()
{
	// TODO:  ڴ
}

//˵->->鿴˵-->Susanӽ
void CedgeSearchingDlg::OnSusanInfo()
{
	// TODO:  ڴ
}

//˵->->鿴˵-->Krischӽ
void CedgeSearchingDlg::OnKrischInfo()
{
	// TODO:  ڴ
}

//˵->->鿴˵-->Prewittӽ
void CedgeSearchingDlg::OnPrewittInfo()
{
	// TODO:  ڴ
}



/***********************************************
*                     ť¼
*
*
**
***********************************************/

//ťҶͼת
void CedgeSearchingDlg::OnBnClickedButtonGray()
{
	if (CONTINUE)
	{
		CONTINUE = false;

		cvtColor(orgMat, graMat, CV_BGR2GRAY);//תΪҶͼ

		orgMat = graMat;

		showImage(&(IplImage)graMat, IDC_SHOWORGIMAGE_STATIC);//ʾͼƬָؼ
	}
}

//ťֵͼ
void CedgeSearchingDlg::OnBnClickedButtonBinary()
{
	binMat = orgMat;

	CV_Assert(binMat.depth() != sizeof(uchar));  //ֻ8bitͼ

	int channels = binMat.channels();            //ȡͼchannel
	int nrows = binMat.rows;                     //
	int ncols = binMat.cols*channels;             //=*channel

	if (binMat.isContinuous())               //жϾǷ൱ֻҪһһά
	{
		ncols *= nrows;
		nrows = 1;                 //һά
	}

	//صҶֵ
	for (int i = 0; i < nrows; i++)
	{
		uchar *p = binMat.ptr<uchar>(i);    //ȡеַ

		for (int j = 0; j < ncols; j++)
		{
			if (p[j] < 100)
				p[j] = 0;
			else
				p[j] = 255;
		}
	}

	orgMat= binMat;//

	showImage(&(IplImage)binMat, IDC_SHOWORGIMAGE_STATIC);//ʾͼƬָؼ
}

//Զⰴť
void CedgeSearchingDlg::OnBnClickedButtonAutocheck()
{
}

//ͼ
void CedgeSearchingDlg::OnBnClickedSavePictureButton()
{
	// TODO:  ڴӿؼ֪ͨ
}

//Ŵʾ
void CedgeSearchingDlg::OnBnClickedButtonAmpl()
{
}


/*--------------------ֹŻ---------------------*/
//Matʼ
Mat m_org = edgMat, m_dst, m_img, m_tmp;
void on_mouse(int event, int x, int y, int flags, void*ustc)//event¼ţx,y꣬flagsקͼ̲Ĵ
{
	/*event¼:
	#define CV_EVENT_MOUSEMOVE 0                 
	#define CV_EVENT_LBUTTONDOWN 1           
	#define CV_EVENT_RBUTTONDOWN 2           Ҽ
	#define CV_EVENT_MBUTTONDOWN 3          м
	#define CV_EVENT_LBUTTONUP 4                   ͷ
	#define CV_EVENT_RBUTTONUP 5                   Ҽͷ
	#define CV_EVENT_MBUTTONUP 6                  мͷ
	#define CV_EVENT_LBUTTONDBLCLK 7         ˫
	#define CV_EVENT_RBUTTONDBLCLK 8         Ҽ˫
	#define CV_EVENT_MBUTTONDBLCLK 9         мͷ
	*/

	static Point pre_pt = (-1, -1);//ʼ  
	static Point cur_pt = (-1, -1);//ʵʱ  
	char temp[16];
	if (event == CV_EVENT_LBUTTONDOWN)//£ȡʼ꣬ͼϸõ㴦Բ  
	{
		m_org.copyTo(m_img);//ԭʼͼƬƵimg  

		pre_pt = Point(x, y);
		putText(m_img, temp, pre_pt, FONT_HERSHEY_SIMPLEX, 0.5, Scalar(0, 0, 0, 255), 1, 8);//ڴʾ  
		circle(m_img, pre_pt, 2, Scalar(255, 255, 0, 0), CV_FILLED, CV_AA, 0);//Բ  
		imshow("ֶŻ", m_img);
	}
	else if (event == CV_EVENT_MOUSEMOVE && !(flags & CV_EVENT_FLAG_LBUTTON))//ûаµƶĴ  
	{
		m_img.copyTo(m_tmp);//imgƵʱͼtmpϣʾʵʱ  

		cur_pt = Point(x, y);
		putText(m_tmp, temp, cur_pt, FONT_HERSHEY_SIMPLEX, 0.5, Scalar(0, 0, 0, 255));//ֻʵʱʾƶ  
		imshow("ֶŻ", m_tmp);
	}
	else if (event == CV_EVENT_MOUSEMOVE && (flags & CV_EVENT_FLAG_LBUTTON))//ʱƶͼϻ  
	{
		m_img.copyTo(m_tmp);

		cur_pt = Point(x, y);
		putText(m_tmp, temp, cur_pt, FONT_HERSHEY_SIMPLEX, 0.5, Scalar(0, 0, 0, 255));
		rectangle(m_tmp, pre_pt, cur_pt, Scalar(0, 255, 0, 0), 1, 8, 0);//ʱͼʵʱʾ϶ʱγɵľ  
		imshow("ֶŻ", m_tmp);
	}
	else if (event == CV_EVENT_LBUTTONUP)//ɿͼϻ  
	{
		m_org.copyTo(m_img);

		cur_pt = Point(x, y);
		putText(m_img, temp, cur_pt, FONT_HERSHEY_SIMPLEX, 0.5, Scalar(0, 0, 0, 255));
		circle(m_img, pre_pt, 2, Scalar(255, 0, 0, 0), CV_FILLED, CV_AA, 0);
		rectangle(m_img, pre_pt, cur_pt, Scalar(0, 255, 0, 0), 1, 8, 0);//ݳʼͽ㣬λimg  
		imshow("ֶŻ", m_img);
		m_img.copyTo(m_tmp);
		//ȡΰΧͼ񣬲浽dst  
		int width = abs(pre_pt.x - cur_pt.x);
		int height = abs(pre_pt.y - cur_pt.y);
		if (width == 0 || height == 0)
			return;

		m_dst = m_org(Rect(min(cur_pt.x, pre_pt.x), min(cur_pt.y, pre_pt.y), width, height));
		//ɾѡоοеֵ
		for (int i = 0; i <m_dst.rows; i++){
			for (int j = 0; j < m_dst.cols; j++){
				for (int k = 0; k < m_dst.channels(); k++)
					m_dst.at<cv::Vec3b>(i, j)[k] = 0;
			}
		}
		imshow("ֶŻ", m_img);
		waitKey(0);
	}
}

void CedgeSearchingDlg::OnBnClickedButtonHandFix()
{
	/**/
	edgMat.copyTo(m_img);
	edgMat.copyTo(m_tmp);

	namedWindow("ֶŻ",WINDOW_AUTOSIZE);//һimg
	setMouseCallback("ֶŻ", on_mouse, 0);//ûص  
	imshow("ֶŻ", m_img);
	waitKey(0);
}


//ͳƷ
void CedgeSearchingDlg::OnBnClickedButtonAnalise()
{
	CPaint *myPaint;

	myPaint = new CPaint();

	myPaint->orgMat = orgMat;//ͼƬ

	INT_PTR nRes;

	nRes=myPaint->DoModal();
}
